# NOTE: Derived from blib/lib/Net/DNS/ToolKit.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package Net::DNS::ToolKit;

#line 733 "blib/lib/Net/DNS/ToolKit.pm (autosplit into blib/lib/auto/Net/DNS/ToolKit/ipv6_aton.al)"
sub ipv6_aton {
  my($ipv6) = @_;
  return undef unless $ipv6;
  if ($ipv6 =~ /:(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/) {	# mixed hex, dot-quad
    return undef if $1 > 255 || $2 > 255 || $3 > 255 || $4 > 255;
    $ipv6 = sprintf("%s:%X%02X:%X%02X",$`,$1,$2,$3,$4);			# convert to pure hex
  }
  return undef unless ($ipv6 =~ /(::|:[a-zA-Z0-9]+)$/);			# pure hex
  my $c = $ipv6 =~ tr/:/:/;						# count the colons
  return undef if $c < 7 && $ipv6 !~ /::/;
  while ($c++ < 7) {							# expand compressed fields
    $ipv6 =~ s/::/:::/;
  }
#  my @hex = split(/:/,$ipv6);						# FAILS on :::::::
  $ipv6 =~ /(\w*):(\w*):(\w*):(\w*):(\w*):(\w*):(\w*):(\w*)/;		# 8, 16 bit pieces
  my @hex = ($1 || 0,$2 || 0,$3 || 0,$4 || 0,$5 || 0,$6 || 0,$7 || 0,$8 || 0);
  $ipv6 = '';
  my $off = 0;
  foreach(@hex) {
    $off = put16(\$ipv6,$off,hex($_));
  }
  return $ipv6;
}

# end of Net::DNS::ToolKit::ipv6_aton
1;
